import Blockly from 'blockly';

const BlocklyStyle = Blockly.Theme.defineTheme('CUSTOM_THEME', {
    'base': Blockly.Themes.Classic,
    'categoryStyles': {
        'custom_category': {
            'colour': "#5ba5a5"                     // 工具箱颜色标识
        },
    },
    'blockStyles': {
        // 块样式目前由四个字段组成：colourPrimary、colourSecondary、colorTertiary 和 hat。
        'custom_text_blocks': {
            'colourPrimary': "#5ba5a5",             //块的背景色，可以用色调或十六进制值定义
            'colourSecondary': "#5ba5a5",            // 如果块是阴影块，则使用此颜色
            'colourTertiary': "#C5EAFF"              // 块的边框颜色
        }
    },
    'componentStyles': {
        'workspaceBackgroundColour': '#fff',   // 工作区背景色
        'toolboxBackgroundColour': 'rgba(236, 241, 247, 0.8)',     // 工具箱背景色
        'toolboxForegroundColour': '#000',     // 工具箱类别文字颜色
        'flyoutBackgroundColour': '#d0f0ffbf',      // 弹出背景颜色
        'flyoutForegroundColour': '#333',         // 弹出标签文本颜色
        'flyoutOpacity': 1,                       // 弹出不透明度
        'scrollbarColour': '#aaa',             // 滚动条颜色
        'scrollbarOpacity': 0.4,                  // 滚动条不透明度
        'insertionMarkerColour': '#f5f5f5',       // 插入标记颜色（不接受颜色名称）
        'insertionMarkerOpacity': 0.3,            // 插入标记不透明度
        'cursorColour': '#f5f5f5',                // 键盘导航模式下显示的光标颜色
    }
})

export default BlocklyStyle